- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files
- Directories
- Examples

- Namespace List
- Namespace Members

Classes | Enumerations | Functions

# mapextraction Namespace Reference

## Classes
class | Component
| This class represents a component in map extraction, like Displacement, Ambient occlusion, etc... More...
class | DisplacementComponent
| This class represents the displacement component. More...
class | VectorDisplacementComponent
| This component represents the vector displacement component. More...
class | NormalComponent
| This class represents the normal vector component. More...
class | AmbientOcclusionComponent
| This class represents the ambient occlusion component. More...
class | PaintLayerScanComponent
| This class represents the paint layer scanner component. This component simply samples a paint layer over the source surface. More...
class | SculptLayerScanComponent
| This class represents the sculpt layer scanner component. This component samples a sculpt layer at the given point on the source mesh. More...
class | Extractor
| This class represents the central module of the extraction. More...
## Enumerations
enum | UtilizerType { utilTexture, utilPtex, utilVertex, utilUnknown }
| This is the type of the final result for map extaction. This controls where the reference points are located on the target mesh. More...
enum | LocateMethod { locRaycast, locSubdivision, locCustom, locUnknown }
| This is the method Mudbox uses to pair sourface points on the target mesh to surface points on the source mesh. More...
enum | Space { spaceWorld, spaceObject, spaceTangent, spaceRawTangent, spaceNormal, spaceUnknown }
| Coordinate space used in varoius places during extraction. More...
enum | VertexAction { vaVertexColor, vaMove, vaDisplace, vaFreeze, vaSculptLayerMask, vaUnknown }
| This is the action which happens with each vertex after extraction. This is only valid if the utilizer type is set to vertex. More...
enum | Antialiasing { aaOff, aa2X, aa4X, aa6X, aa8X, aaUnknown }
| Type of the antialiasing applied to extracted textures. This is only valid if utilizer type is set to texture. More...
enum | Sampling { sampleFurthestOutside, sampleFurthestInside, sampleClosesToTarget, sampleUnknown }
| How the intersection point is chosen when there are multiple candidates. This is only valid if locate method is set to raycast. More...
enum | Quality { qualFastest, qualFast, qualNormal, qualGood, qualBest, qualUnknown }
| Quality of ambient occlusion extraction. More...
enum | Resolution { res256, res512, res1024, res2048, res4096, resUnknown }
| Resolution of a texture map. This is always square. More...
enum | Compatibility { compMaya, compMax, compUnknown }
| Compatibility of the extracted normal map. More...
## Functions
MEADLL class Extractor | CreateNewOperation (void)
| Creates a new extractor node.
MEADLL int | OperationCount (void)
| Returns the number of extractor nodes in the scene.
MEADLL class Extractor | OperationByIndex (int iIndex)
| Returns a given existing extractor node.

## Enumeration Type Documentation

enum UtilizerType

Search for all occurrences

This is the type of the final result for map extaction. This controls where the reference points are located on the target mesh.

Enumerator:

  utilTexture | Search for all occurrences
  utilPtex | Traditional textures, which are saved as plain image files (jpg, png, etc..), one for each tile. Target mesh needs texture coordinates. Search for all occurrences
  utilVertex | Extracting to a ptex file. Search for all occurrences
  utilUnknown | Extracting data to vertices of the target mesh. In this case the result is not a file, but some kind of operation on the target mesh, based on the result of the extraction. This is not exposed on the UI currently, but can be used programmatically. Search for all occurrences

Definition at line 25 of file MapExtractorAPI.h.

        {
            utilTexture,
            utilPtex,
            utilVertex,

            utilUnknown
        };

enum LocateMethod

Search for all occurrences

This is the method Mudbox uses to pair sourface points on the target mesh to surface points on the source mesh.

Enumerator:

  locRaycast | Search for all occurrences
  locSubdivision | With this method, mudbox fires a ray which crosses the target mesh in the desired point, and the direction is the same as the opposite of the. surface normal. Mudbox then finds the intersection of this ray, and the source mesh. Search for all occurrences
  locCustom | This method can only be used, if the target mesh and the source mesh are subdivision levels of the same object (or they have the. matching topology). Mudbox calculates the point pairs based on this subdivision relationship. Search for all occurrences
  locUnknown | This method can only be used, when there is a precalculated relationship between the source and target mesh. This is the case for example, after retopology, the new mesh can be used as target, the old mesh can be used as source. Search for all occurrences

Definition at line 35 of file MapExtractorAPI.h.

        {
            locRaycast,

            locSubdivision,

            locCustom,

            locUnknown
        };

enum Space

Search for all occurrences

Coordinate space used in varoius places during extraction.

Enumerator:

  spaceWorld | Search for all occurrences
  spaceObject | World space (or global space). Search for all occurrences
  spaceTangent | Object space, which is always related to some mesh in the scene. Search for all occurrences
  spaceRawTangent | This is a special space, which is changing over the mesh, so it also depends on a location. For more details, look for various tangent space documentation on the internet, like: Lengyel, Eric. �Computing Tangent Space Basis Vectors for an Arbitrary Mesh�. Terathon Software 3D Graphics Library, 2001. http://www.terathon.com/code/tangent.html Search for all occurrences
  spaceNormal | Same as above, but the tangent and bitangent remains unnormalized and their direction is not aligned to the surface normal. The length of the surface normal is changed to the geometric average of the length of the tangent and bitangent vectors. Search for all occurrences
  spaceUnknown | This is a special space used in displacement map extraction. Used only internally. Search for all occurrences

Examples:
  MeshDisplace/displacer.h.

Definition at line 47 of file MapExtractorAPI.h.

        {
            spaceWorld,
            spaceObject,
            spaceTangent,

            spaceRawTangent,

            spaceNormal,
            spaceUnknown
        };

enum VertexAction

Search for all occurrences

This is the action which happens with each vertex after extraction. This is only valid if the utilizer type is set to vertex.

Enumerator:

  vaVertexColor | Search for all occurrences
  vaMove | Each vertex gets a new vertex color asigned, based on the calculated data. Search for all occurrences
  vaDisplace | The vertex position is modified based on the extracted data (the data as a vector is added to the current vertex position). Search for all occurrences
  vaFreeze | Move the vertex along the surface normal. Search for all occurrences
  vaSculptLayerMask | Change the vertex freeze value based on the extracted data. Search for all occurrences
  vaUnknown | Change the mask for the given sculpt layer based on the extracted data. Search for all occurrences

Definition at line 61 of file MapExtractorAPI.h.

        {
            vaVertexColor,
            vaMove,
            vaDisplace,
            vaFreeze,
            vaSculptLayerMask,
            vaUnknown
        };

enum Antialiasing

Search for all occurrences

Type of the antialiasing applied to extracted textures. This is only valid if utilizer type is set to texture.

Enumerator:

  aaOff | Search for all occurrences
  aa2X | Search for all occurrences
  aa4X | Search for all occurrences
  aa6X | Search for all occurrences
  aa8X | Search for all occurrences
  aaUnknown | Search for all occurrences

Definition at line 72 of file MapExtractorAPI.h.

        {
            aaOff,
            aa2X,
            aa4X,
            aa6X,
            aa8X,
            aaUnknown
        };

enum Sampling

Search for all occurrences

How the intersection point is chosen when there are multiple candidates. This is only valid if locate method is set to raycast.

Enumerator:

  sampleFurthestOutside | Search for all occurrences
  sampleFurthestInside | The furthest is chosen, outside of the target mesh. Search for all occurrences
  sampleClosesToTarget | The furthest is chosen, inside the target mesh. Search for all occurrences
  sampleUnknown | The closest to the target mesh is chosen. Search for all occurrences

Definition at line 83 of file MapExtractorAPI.h.

        {
            sampleFurthestOutside,
            sampleFurthestInside,
            sampleClosesToTarget,
            sampleUnknown
        };

enum Quality

Search for all occurrences

Quality of ambient occlusion extraction.

Enumerator:

  qualFastest | Search for all occurrences
  qualFast | Search for all occurrences
  qualNormal | Search for all occurrences
  qualGood | Search for all occurrences
  qualBest | Search for all occurrences
  qualUnknown | Search for all occurrences

Definition at line 92 of file MapExtractorAPI.h.

        {
            qualFastest,
            qualFast,
            qualNormal,
            qualGood,
            qualBest,
            qualUnknown
        };

enum Resolution

Search for all occurrences

Resolution of a texture map. This is always square.

Enumerator:

  res256 | Search for all occurrences
  res512 | Search for all occurrences
  res1024 | Search for all occurrences
  res2048 | Search for all occurrences
  res4096 | Search for all occurrences
  resUnknown | Search for all occurrences

Definition at line 103 of file MapExtractorAPI.h.

        {
            res256,
            res512,
            res1024,
            res2048,
            res4096,
            resUnknown
        };

enum Compatibility

Search for all occurrences

Compatibility of the extracted normal map.

Enumerator:

  compMaya | Search for all occurrences
  compMax | Search for all occurrences
  compUnknown | Search for all occurrences

Definition at line 114 of file MapExtractorAPI.h.

        {
            compMaya,
            compMax,
            compUnknown
        };

## Function Documentation

MEADLL class Extractor mapextraction::CreateNewOperation | ( | void |  | ) |

Search for all occurrences

Creates a new extractor node.

Examples:
  MeshDisplace/displacer.cpp.

MEADLL int mapextraction::OperationCount | ( | void |  | ) |

Search for all occurrences

Returns the number of extractor nodes in the scene.

MEADLL class Extractor mapextraction::OperationByIndex | ( | int | iIndex | ) |

Search for all occurrences

Returns a given existing extractor node.